%bcond_with     testsuite

Summary:        Perl library for transparent SSL
Name:           perl-IO-Socket-SSL
Version:        2.083
Release:        3%{?dist}
License:        (GPL+ or Artistic) and MPLv2.0
URL:            https://metacpan.org/release/IO-Socket-SSL
Source0:        https://cpan.metacpan.org/modules/by-module/IO/IO-Socket-SSL-%{version}.tar.gz
Patch3000:      IO-Socket-SSL-2.082-use-system-default-cipher-list.patch
Patch3001:      IO-Socket-SSL-2.082-use-system-default-SSL-version.patch
Patch3002:      IO-Socket-SSL-2.080-Test-client-performs-Post-Handshake-Authentication.patch

BuildRequires:  coreutils make
BuildRequires:  perl-generators perl-interpreter perl(ExtUtils::MakeMaker) >= 6.76
BuildRequires:  openssl-libs >= 0.9.8 perl(Carp) perl(Config) perl(constant)
BuildRequires:  perl(Errno) perl(Exporter) perl(HTTP::Tiny) perl(IO::Socket)
BuildRequires:  perl(IO::Socket::INET) perl(IO::Socket::IP) >= 0.31 openssl
BuildRequires:  perl(Net::SSLeay) >= 1.46 perl(Scalar::Util) perl(warnings)
BuildRequires:  perl(Socket) >= 1.95 perl(strict) perl(URI::_idna) perl(vars)
BuildRequires:  perl(Data::Dumper) perl(File::Temp) perl(FindBin) perl(IO::Select)
BuildRequires:  perl(Test::More) >= 0.88 perl(utf8) procps
%if %{with testsuite}
BuildRequires:  perl(IO::Socket::INET6) >= 2.62
BuildRequires:  perl(Net::IDN::Encode) perl(Net::LibIDN2) perl(IPC::Run)
%endif
Requires:       openssl-libs >= 0.9.8
Requires:       perl(Config) perl(HTTP::Tiny) perl(IO::Socket::INET)
Requires:       perl(IO::Socket::IP) >= 0.31 perl(Socket) >= 1.95 perl(URI::_idna)

BuildArch:	noarch

%description
As a true drop-in replacement for IO::Socket::INET, IO::Socket::SSL is able to encrypt 
data using SSL before it is transferred to a remote server or client. This module supports 
all the additional features that one needs to write a full-featured SSL client or server 
application: multiple SSL contexts, cipher selection, certificate verification, and
SSL version selection.In addition, it works perfectly with mod_perl.

%prep
%setup -q -n IO-Socket-SSL-%{version}
%autopatch -p0 -m 3000 -M 3001
%autopatch -p1 -m 3002

%build
NO_NETWORK_TESTING=1 perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1
%make_build

%install
%make_install
%{_fixperms} -c %{buildroot}

%check
%if %{with testsuite}
make test
%endif

%files
%doc BUGS Changes README docs/ example/
%doc %{perl_vendorlib}/IO/Socket/SSL.pod
%dir %{perl_vendorlib}/IO/
%dir %{perl_vendorlib}/IO/Socket/
%dir %{perl_vendorlib}/IO/Socket/SSL/
%{perl_vendorlib}/IO/Socket/SSL.pm
%{perl_vendorlib}/IO/Socket/SSL/Intercept.pm
%{perl_vendorlib}/IO/Socket/SSL/Utils.pm
%{perl_vendorlib}/IO/Socket/SSL/PublicSuffix.pm
%{_mandir}/man3/IO::Socket::SSL::PublicSuffix.3*
%{_mandir}/man3/IO::Socket::SSL.3*
%{_mandir}/man3/IO::Socket::SSL::Intercept.3*
%{_mandir}/man3/IO::Socket::SSL::Utils.3*

%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.083-3
- Rebuilt for loongarch release

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.083-2
- Rebuilt for OpenCloudOS Stream 23.09

* Wed Aug 02 2023 Xiaojie Chen <jackxjchen@tencent.com> - 2.083-1
- Upgrade to upstream version 2.074
- Remove perl(MODULE_COMPAT) which will be generated by perl-generators >= 1.15

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.074-4
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.074-3
- Rebuilt for OpenCloudOS Stream 23

* Thu Feb 16 2023 Shuo Wang <abushwang@tencent.com> - 2.074-2
- remove unused buildrequires

* Tue Aug 23 2022 Wang Guodong <gordonwwang@tencent.com> - 2.074-1
- package init.
